Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_test.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_test.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_test.h	(revision 429)
@@ -4,5 +4,5 @@
  *      Advanced Standard Profile Kernel
  * 
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -36,5 +36,5 @@
  *  の責任を負わない．
  * 
- *  $Id$
+ *  $Id: core_test.h 1244 2019-07-16 21:41:05Z ertl-hiro $
  */
 
@@ -54,7 +54,6 @@
 
 /*
- *  CPU例外の発生
+ *  不正アドレスの定義（メモリのない番地に設定する）
  */
-
 #ifndef ILLEGAL_IADDR
 #define ILLEGAL_IADDR			0xd0000000U		/* 不正命令アドレス */
@@ -66,67 +65,96 @@
 
 /*
+ *  サンプルプログラムで用いるCPU例外の発生
+ */
+#if defined(USE_CPUEXC_SVC)
+
+#define CPUEXC1					EXCNO_SVC		/* スーパバイザコール */
+#define RAISE_CPU_EXCEPTION		RAISE_CPU_EXCEPTION_SVC
+#define PREPARE_RETURN_CPUEXC	PREPARE_RETURN_CPUEXC_SVC
+
+#elif defined(USE_CPUEXC_PABORT)
+
+#define CPUEXC1					EXCNO_PABORT	/* プリフェッチアボート */
+#define RAISE_CPU_EXCEPTION		RAISE_CPU_EXCEPTION_PABORT
+#define PREPARE_RETURN_CPUEXC	PREPARE_RETURN_CPUEXC_PABORT
+
+#elif defined(USE_CPUEXC_DABORT)
+
+#define CPUEXC1					EXCNO_DABORT	/* データアボート */
+#define RAISE_CPU_EXCEPTION		RAISE_CPU_EXCEPTION_DABORT
+#define PREPARE_RETURN_CPUEXC	PREPARE_RETURN_CPUEXC_DABORT
+
+#elif defined(USE_CPUEXC_FATAL)
+
+#define CPUEXC1					EXCNO_FATAL		/* フェイタルデータアボート */
+#define RAISE_CPU_EXCEPTION		RAISE_CPU_EXCEPTION_FATAL
+/* フェイタルデータアボート例外ハンドラからリターンしてはならない */
+
+#else
+
+#define CPUEXC1					EXCNO_UNDEF		/* 未定義命令 */
+#define RAISE_CPU_EXCEPTION		RAISE_CPU_EXCEPTION_UNDEF
+#define PREPARE_RETURN_CPUEXC	PREPARE_RETURN_CPUEXC_UNDEF
+
+#endif
+
+/*
  *  スーパバイザコールによるCPU例外の発生
  *
- *  CPU例外ハンドラから，そのままリターンすることができる．svc命令によ
- *  りlrレジスタが上書きされるため，lrレジスタは破壊されるものと指定し
- *  ている．
+ *  svc #0によりCPU例外を発生させる．svc命令によりlrレジスタが上書きさ
+ *  れるため，lrレジスタは破壊されるものと指定している．CPU例外ハンド
+ *  ラからそのままリターンすることで，svc命令の次の命令から実行が継続
+ *  する．
  */
-#if defined(USE_SVC_CPUEXC)
-
-#define CPUEXC1					EXCNO_SVC		/* スーパバイザコール */
-#define RAISE_CPU_EXCEPTION		Asm("svc #0":::"lr")
-#define PREPARE_RETURN_CPUEXC
+#define RAISE_CPU_EXCEPTION_SVC			Asm("svc #0":::"lr")
+#define PREPARE_RETURN_CPUEXC_SVC
 
 /*
  *  プリフェッチアボートによるCPU例外の発生
  *
- *  プリフェッチアボートを起こした命令をスキップしてCPU例外ハンドラから
- *  リターンするために，戻り番地はそのままで良い（ARMモードで使うことを
- *  想定）．
+ *  不正な番地を関数の先頭番地として呼び出すことで，プリフェッチアボー
+ *  トによるCPU例外を発生させる．不正な番地に分岐した命令をスキップし
+ *  てCPU例外ハンドラからリターンするために，戻り番地には，lrレジスタ
+ *  の値（不正な番地への分岐命令からのリターン番地が入っている）を設定
+ *  する．
  */
-#elif defined(USE_PABORT_CPUEXC)
-
-#define CPUEXC1					EXCNO_PABORT	/* プリフェッチアボート */
-#define RAISE_CPU_EXCEPTION		((void (*)(void)) ILLEGAL_IADDR)()
-#define PREPARE_RETURN_CPUEXC
+#define RAISE_CPU_EXCEPTION_PABORT		(((void (*)(void)) ILLEGAL_IADDR)())
+#define PREPARE_RETURN_CPUEXC_PABORT	(((T_EXCINF *) p_excinf)->pc \
+											= ((T_EXCINF *) p_excinf)->lr)
 
 /*
  *  データアボートによるCPU例外の発生
  *
- *  データアボートを起こした命令をスキップしてCPU例外ハンドラからリター
- *  ンするために，戻り番地から4を減算する（ARMモードで使うことを想定）．
+ *  不正な番地をリードすることで，データアボートによるCPU例外を発生さ
+ *  せる．データアボートを起こした命令をスキップしてCPU例外ハンドラか
+ *  らリターンするために，戻り番地から4を減算する（ARMモードで使うこと
+ *  を想定している）．
  */
-#elif defined(USE_DABORT_CPUEXC)
-
-#include "arm.h"
-#define CPUEXC1					EXCNO_DABORT	/* データアボート */
-#define RAISE_CPU_EXCEPTION		(void)(*((volatile uint32_t *) ILLEGAL_DADDR))
-#define PREPARE_RETURN_CPUEXC	((T_EXCINF *) p_excinf)->pc -= 4U
+#define RAISE_CPU_EXCEPTION_DABORT		(void)(*((volatile uint32_t *) \
+															ILLEGAL_DADDR))
+#define PREPARE_RETURN_CPUEXC_DABORT	(((T_EXCINF *) p_excinf)->pc -= 4U)
 
 /*
- *  フェイタルデータアボート処理
+ *  フェイタルデータアボートによるCPU例外の発生
  *
- *  スタックポインタを不正にして，フェイタルデータアボート処理を行わせ
- *  る．CPU例外ハンドラからはリターンできない．
+ *  スタックポインタを不正にして，未定義命令を実行することで，フェイタ
+ *  ルデータアボートによるCPU例外を発生させる．CPU例外ハンドラからリター
+ *  ンしてはならない．
  */
-#elif defined(USE_FATAL_DABORT_CPUEXC)
-
-#define CPUEXC1					EXCNO_DABORT	/* データアボート */
-#define RAISE_CPU_EXCEPTION		Asm("mov sp, %0"::"I"(ILLEGAL_DADDR))
+#define RAISE_CPU_EXCEPTION_FATAL		Asm("mov sp, %0\n" \
+										  "\t.word 0xf0500090" \
+										  ::"I"(ILLEGAL_DADDR))
 
 /*
  *  未定義命令によるCPU例外の発生
  *
- *  RAISE_CPU_EXCEPTIONは，ARMモードで使うことを想定している．CPU例外ハ
- *  ンドラから，そのままリターンすることができる．使用している未定義命
- *  令は，"Multiply and multiply accumulate"命令群のエンコーディング内
- *  における未定義命令である．
+ *  未定義命令によりCPU例外を発生させる．使用している未定義命令は，
+ *  "Multiply and multiply accumulate"命令群のエンコーディング内におけ
+ *  る未定義命令である．CPU例外ハンドラからそのままリターンすることで，
+ *  未定義命令の次の命令から実行が継続する（ARMモードで使うことを想定
+ *  している）．
  */
-#else
+#define RAISE_CPU_EXCEPTION_UNDEF		Asm(".word 0xf0500090")
+#define PREPARE_RETURN_CPUEXC_UNDEF
 
-#define CPUEXC1					EXCNO_UNDEF		/* 未定義命令 */
-#define RAISE_CPU_EXCEPTION		Asm(".word 0xf0500090")
-#define PREPARE_RETURN_CPUEXC
-
-#endif
 #endif /* TOPPERS_CORE_TEST_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_unrename.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_unrename.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/core_unrename.h	(revision 429)
@@ -26,6 +26,4 @@
 #undef dabort_handler
 #undef fiq_handler
-#undef current_cpsr
-#undef set_cpsr
 
 /*
@@ -34,4 +32,5 @@
 #undef excpt_nest_count
 #undef arm_mmu_initialize
+#undef arm_fpu_initialize
 #undef core_initialize
 #undef core_terminate
@@ -40,4 +39,20 @@
 #undef default_int_handler
 #undef default_exc_handler
+
+/*
+ *  mpcore_kernel_impl.c
+ */
+#undef mpcore_initialize
+#undef mpcore_terminate
+
+/*
+ *  mpcore_timer.c
+ */
+#undef target_hrt_initialize
+#undef target_hrt_terminate
+#undef target_hrt_handler
+#undef target_ovrtimer_initialize
+#undef target_ovrtimer_terminate
+#undef target_ovrtimer_handler
 
 /*
@@ -66,10 +81,4 @@
 #undef pl310_clean_and_invalidate_all
 
-/*
- *  target_kernel_impl.c
- */
-#undef arm_tnum_memory_area
-#undef arm_memory_area
-
 
 #endif /* TOPPERS_CORE_RENAME_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.c	(revision 429)
@@ -227,5 +227,5 @@
 	 */
 	gicd_set_priority(intno, INT_IPM(intpri));
-	gicd_set_target(intno, 1U << arm_prc_index());
+	gicd_set_target(intno, 1U << get_my_prcidx());
 
 	/*
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_kernel_impl.h	(revision 429)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2006-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -67,7 +67,7 @@
  *  割込み番号の定義
  */
-#define GIC_INTNO_SGI0		0U
-#define GIC_INTNO_PPI0		16U
-#define GIC_INTNO_SPI0		32U
+#define GIC_INTNO_SGI0		UINT_C(0)
+#define GIC_INTNO_PPI0		UINT_C(16)
+#define GIC_INTNO_SPI0		UINT_C(32)
 
 /*
@@ -126,5 +126,5 @@
 #define GICC_EOIR		GIC_REG(GICC_BASE, 0x10)
 #define GICC_RPR		GIC_REG(GICC_BASE, 0x14)
-#define GICC_HPIR		GIC_REG(GICC_BASE, 0x18)
+#define GICC_HPPIR		GIC_REG(GICC_BASE, 0x18)
 
 /*
@@ -198,5 +198,5 @@
 gicc_set_priority(uint_t pri)
 {
-	sil_wrw_mem(GICC_PMR, pri);
+	sil_swrw_mem(GICC_PMR, pri);
 }
 
@@ -230,5 +230,5 @@
 gicd_disable_int(INTNO intno)
 {
-	sil_wrw_mem(GICD_ICENABLER(intno / 32), (1U << (intno % 32)));
+	sil_swrw_mem(GICD_ICENABLER(intno / 32), (1U << (intno % 32)));
 }
 
@@ -239,5 +239,5 @@
 gicd_enable_int(INTNO intno)
 {
-	sil_wrw_mem(GICD_ISENABLER(intno / 32), (1U << (intno % 32)));
+	sil_swrw_mem(GICD_ISENABLER(intno / 32), (1U << (intno % 32)));
 }
 
@@ -248,5 +248,5 @@
 gicd_clear_pending(INTNO intno)
 {
-	sil_wrw_mem(GICD_ICPENDR(intno / 32), (1U << (intno % 32)));
+	sil_swrw_mem(GICD_ICPENDR(intno / 32), (1U << (intno % 32)));
 }
 
@@ -257,5 +257,5 @@
 gicd_set_pending(INTNO intno)
 {
-	sil_wrw_mem(GICD_ISPENDR(intno / 32), (1U << (intno % 32)));
+	sil_swrw_mem(GICD_ISPENDR(intno / 32), (1U << (intno % 32)));
 }
 
@@ -271,4 +271,13 @@
 
 /*
+ *  ソフトウェア生成割込み（SGI）の生成
+ */
+Inline void
+gicd_raise_sgi(INTNO intno)
+{
+	sil_swrw_mem(GICD_SGIR, (0x02000000 | intno));
+}
+
+/*
  *  割込みのコンフィグレーション
  */
@@ -279,8 +288,10 @@
 	uint32_t	reg;
 
-	reg = sil_rew_mem(GICD_ICFGR(intno / 16));
-	reg &= ~(0x03U << shift);
-	reg |= (config << shift);
-	sil_wrw_mem(GICD_ICFGR(intno / 16), reg);
+	if (intno >= GIC_INTNO_PPI0) {
+		reg = sil_rew_mem(GICD_ICFGR(intno / 16));
+		reg &= ~(0x03U << shift);
+		reg |= (config << shift);
+		sil_wrw_mem(GICD_ICFGR(intno / 16), reg);
+	}
 }
 
@@ -318,6 +329,6 @@
  *  割込みターゲットプロセッサの設定
  *
- *  prcsは，ターゲットとするプロセッサを表すビットのビット毎論理和で指
- *  定する．
+ *  affinityは，ターゲットとするプロセッサを表すビットのビット毎論理和
+ *  で指定する．
  *		プロセッサ0 : 0x01
  *		プロセッサ1 : 0x02
@@ -326,5 +337,5 @@
  */
 Inline void
-gicd_set_target(INTNO intno, uint_t prcs)
+gicd_set_target(INTNO intno, uint_t affinity)
 {
 	uint_t		shift = (intno % 4) * 8;
@@ -333,5 +344,5 @@
 	reg = sil_rew_mem(GICD_ITARGETSR(intno / 4));
 	reg &= ~(0xffU << shift);
-	reg |= (prcs << shift);
+	reg |= (affinity << shift);
 	sil_wrw_mem(GICD_ITARGETSR(intno / 4), reg);
 }
@@ -373,4 +384,13 @@
  */
 #ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  割込み属性の設定のチェック
+ */
+Inline bool_t
+check_intno_cfg(INTNO intno)
+{
+	return(intcfg_table[intno] != 0U);
+}
 
 /*
@@ -393,44 +413,76 @@
 
 /*
+ *  割込み要求禁止フラグが操作できる割込み番号の範囲の判定
+ */
+#ifdef GIC_SUPPORT_DISABLE_SGI
+#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
+#else /* GIC_SUPPORT_DISABLE_SGI */
+#define VALID_INTNO_DISINT(intno) \
+				(GIC_INTNO_PPI0 <= (intno) && (intno) <= TMAX_INTNO)
+#endif /* GIC_SUPPORT_DISABLE_SGI */
+
+/*
  *  割込み要求禁止フラグのセット
- *
- *  intnoで指定された割込み要求ラインに対する割込み要求禁止フラグのセッ
- *  トし，割込みを禁止する．割込み属性が設定されていない割込み要求ライ
- *  ンが指定された場合には，falseを返す．
- */
-Inline bool_t
+ */
+Inline void
 disable_int(INTNO intno)
 {
-	if (intcfg_table[intno] == 0U) {
-		return(false);
-	}
 	gicd_disable_int(intno);
-	return(true);
 }
 
 /* 
  *  割込み要求禁止フラグのクリア
- *
- *  intnoで指定された割込み要求ラインに対する割込み要求禁止フラグのクリ
- *  アし，割込みを許可する．割込み属性が設定されていない割込み要求ライ
- *  ンが指定された場合には，falseを返す．
+ */
+Inline void
+enable_int(INTNO intno)
+{
+	gicd_enable_int(intno);
+}
+
+/*
+ *  割込み要求がクリアできる割込み番号の範囲の判定
+ */
+#define VALID_INTNO_CLRINT(intno) \
+				(GIC_INTNO_PPI0 <= (intno) && (intno) <= TMAX_INTNO)
+
+/*
+ *  割込み要求がクリアできる状態か？
  */
 Inline bool_t
-enable_int(INTNO intno)
-{
-	if (intcfg_table[intno] == 0U) {
-		return(false);
+check_intno_clear(INTNO intno)
+{
+	return(true);
+}
+
+/*
+ *  割込み要求のクリア
+ */
+Inline void
+clear_int(INTNO intno)
+{
+	gicd_clear_pending(intno);
+}
+
+/*
+ *  割込みが要求できる状態か？
+ */
+Inline bool_t
+check_intno_raise(INTNO intno)
+{
+	return(true);
+}
+
+/*
+ *  割込みの要求
+ */
+Inline void
+raise_int(INTNO intno)
+{
+	if (intno < GIC_INTNO_PPI0) {
+		gicd_raise_sgi(intno);
 	}
-	gicd_enable_int(intno);
-	return(true);
-}
-
-/*
- *  割込み要求のクリア
- */
-Inline void
-clear_int(INTNO intno)
-{
-	gicd_clear_pending(intno);
+	else {
+		gicd_set_pending(intno);
+	}
 }
 
@@ -444,13 +496,4 @@
 }
 
-/*
- *  割込み要求のセット
- */
-Inline void
-raise_int(INTNO intno)
-{
-	gicd_set_pending(intno);
-}
-
 #endif /* TOPPERS_MACRO_ONLY */
 #endif /* TOPPERS_GIC_KERNEL_IMPL_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_support.S
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_support.S	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/gic_support.S	(revision 429)
@@ -5,5 +5,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -70,22 +70,33 @@
 	 *  割込み要因を取得する．
 	 */
+#ifdef GIC_PL390_ERRATA			/* GIC 390 Errata 801120への対策 */
+	ldr		r1, =GICC_HPPIR
+	ldr		r0, [r1]	
+#endif /* GIC_PL390_ERRATA */
 	ldr		r1, =GICC_IAR
 	ldr		r3, [r1]
-
-	/*
-	 *  割込み番号を求める．
-	 */
 	lsl		r4, r3, #22			/* 下位10ビットを取り出す */
 	lsr		r4, r4, #22
 
-	/*
-	 *  割込み要求をクリアする．
-	 */
-	and		r0, r4, #31
-	mov		r2, #1
-	lsl		r0, r2, r0
-	ldr		r2, =GICD_ICPENDR(0)
-	lsr		r1, r4, #5
-	str		r0, [r2,r1,lsl #2]
+#ifdef GIC_PL390_ERRATA			/* GIC 390 Errata 733075への対策 */
+	movw	r0, #1023
+	cmp		r4, r0
+	beq		irc_begin_int_errata_1
+	movw	r0, #1022
+	cmp		r4, r0
+	beq		irc_begin_int_errata_1
+	cmp		r3, #0
+	bne		irc_begin_int_errata_2
+	ldr		r1, =GICD_ISACTIVER(0)		/* 割込み要求があるかチェック */
+	ldr		r0, [r1]
+	tst		r0, #0x01
+	movweq	r4, #1024					/* 無効な割込みとみなす */
+ALABEL(irc_begin_int_errata_1)
+	ldr		r1, =GICD_IPRIORITYR(0)		/* 割込み優先度レジスタ0に書き込み */
+	ldr		r0, [r1]
+	str		r0, [r1]
+	asm_data_sync_barrier r0
+ALABEL(irc_begin_int_errata_2)
+#endif /* GIC_PL390_ERRATA */
 
 	/*
@@ -107,5 +118,5 @@
 
 	/*
-	 *  割込み番号を返値としてリターンする．
+	 *  r4に割込み番号を入れた状態でリターンする．
 	 */
 	bx		lr
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore.h	(revision 429)
@@ -0,0 +1,238 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		MPCoreサポートモジュール
+ */
+
+#ifndef TOPPERS_MPCORE_H
+#define TOPPERS_MPCORE_H
+
+#include <sil.h>
+#include "arm.h"
+
+/*
+ *  CP15の補助制御レジスタ（ACTLR）の設定値
+ */
+#if __TARGET_ARCH_ARM == 6
+#define CP15_ACTLR_SMP			UINT_C(0x00000020)
+#else /* __TARGET_ARCH_ARM == 6 */
+#define CP15_ACTLR_SMP			UINT_C(0x00000040)
+#endif /* __TARGET_ARCH_ARM == 6 */
+
+/*
+ *  SCU（スヌープ制御ユニット）関連の定義
+ */
+
+/*
+ *  SCUレジスタの番地の定義
+ */
+#define MPCORE_SCU_BASE		(MPCORE_PMR_BASE + 0x0000U)
+#define MPCORE_SCU_CTRL		((uint32_t *)(MPCORE_SCU_BASE + 0x00U))
+#define MPCORE_SCU_CONFIG	((uint32_t *)(MPCORE_SCU_BASE + 0x04U))
+#define MPCORE_SCU_CPUSTAT	((uint32_t *)(MPCORE_SCU_BASE + 0x08U))
+#define MPCORE_SCU_INVALL	((uint32_t *)(MPCORE_SCU_BASE + 0x0cU))
+
+/*
+ *  SCU制御レジスタ（MPCORE_SCU_CTRL）の設定値
+ */
+#define MPCORE_SCU_CTRL_ENABLE		UINT_C(0x00000001)
+
+/*
+ *  SCUパワーステータスレジスタ（MPCORE_SCU_CPUSTAT）の設定値
+ */
+#define MPCORE_SCU_CPUSTAT_ALLNORMAL	UINT_C(0x00000000)
+
+/*
+ *  SCUインバリデートオールレジスタ（MPCORE_SCU_INVALL）の設定値
+ */
+#define MPCORE_SCU_INVALL_ALLWAYS	UINT_C(0x0000ffff)
+
+/*
+ *  GIC関連の定義
+ */
+
+/*
+ *  GICレジスタのベースアドレスの定義
+ */
+#ifndef GICC_BASE
+#define GICC_BASE			(MPCORE_PMR_BASE + UINT_C(0x0100))
+#endif /* GICC_BASE */
+
+#ifndef GICD_BASE
+#define GICD_BASE			(MPCORE_PMR_BASE + UINT_C(0x1000))
+#endif /* GICD_BASE */
+
+/*
+ *  割込み番号の定義
+ */
+#define MPCORE_IRQNO_GTC	27U			/* グローバルタイマの割込み番号 */
+#define MPCORE_IRQNO_TMR	29U			/* プライベートタイマの割込み番号 */
+#define MPCORE_IRQNO_WDG	30U			/* ウォッチドッグの割込み番号 */
+
+/*
+ *  プライベートタイマとウォッチドッグ関連の定義
+ */
+
+/*
+ *  プライベートタイマとウォッチドッグレジスタの番地の定義
+ */
+#define MPCORE_TMR_BASE		(MPCORE_PMR_BASE + 0x0600U)
+#define MPCORE_TMR_LR		((uint32_t *)(MPCORE_TMR_BASE + 0x00U))
+#define MPCORE_TMR_CNT		((uint32_t *)(MPCORE_TMR_BASE + 0x04U))
+#define MPCORE_TMR_CTRL		((uint32_t *)(MPCORE_TMR_BASE + 0x08U))
+#define MPCORE_TMR_ISR		((uint32_t *)(MPCORE_TMR_BASE + 0x0cU))
+#define MPCORE_WDG_LR		((uint32_t *)(MPCORE_TMR_BASE + 0x20U))
+#define MPCORE_WDG_CNT		((uint32_t *)(MPCORE_TMR_BASE + 0x24U))
+#define MPCORE_WDG_CTRL		((uint32_t *)(MPCORE_TMR_BASE + 0x28U))
+#define MPCORE_WDG_ISR		((uint32_t *)(MPCORE_TMR_BASE + 0x2cU))
+#define MPCORE_WDG_RST		((uint32_t *)(MPCORE_TMR_BASE + 0x30U))
+#define MPCORE_WDG_DIS		((uint32_t *)(MPCORE_TMR_BASE + 0x34U))
+
+/*
+ *  プライベートタイマ制御レジスタ（MPCORE_TMR_CTRL）の設定値
+ */
+#define MPCORE_TMR_CTRL_DISABLE			0x00U
+#define MPCORE_TMR_CTRL_ENABLE			0x01U
+#define MPCORE_TMR_CTRL_AUTORELOAD		0x02U
+#define MPCORE_TMR_CTRL_ENAINT			0x04U
+#define MPCORE_TMR_CTRL_PS_SHIFT		8
+
+/*
+ *  プライベートタイマ割込みステータスレジスタ（MPCORE_TMR_ISR）の設定値
+ */
+#define MPCORE_TMR_ISR_EVENTFLAG		0x01U
+
+/*
+ *  ウォッチドッグ制御レジスタ（MPCORE_WDG_CTRL）の参照値
+ */
+#define MPCORE_WDG_CTRL_DISABLE			0x00U
+#define MPCORE_WDG_CTRL_ENABLE			0x01U
+#define MPCORE_WDG_CTRL_AUTORELOAD		0x02U
+#define MPCORE_WDG_CTRL_ENAINT			0x04U
+#define MPCORE_WDG_CTRL_WDGMODE			0x08U
+#define MPCORE_WDG_CTRL_PS_SHIFT		8
+
+/*
+ *  ウォッチドッグ割込みステータスレジスタ（MPCORE_WDG_ISR）の参照値
+ */
+#define MPCORE_WDG_ISR_EVENTFLAG		0x01U
+
+/*
+ *  グローバルタイマ関連の定義
+ */
+#if __TARGET_ARCH_ARM == 7
+
+/*
+ *  グローバルタイマレジスタの番地の定義
+ */
+#define MPCORE_GTC_BASE		(MPCORE_PMR_BASE + 0x0200U)
+#define MPCORE_GTC_COUNT_L	((uint32_t *)(MPCORE_GTC_BASE + 0x00U))
+#define MPCORE_GTC_COUNT_U	((uint32_t *)(MPCORE_GTC_BASE + 0x04U))
+#define MPCORE_GTC_CTRL		((uint32_t *)(MPCORE_GTC_BASE + 0x08U))
+#define MPCORE_GTC_ISR		((uint32_t *)(MPCORE_GTC_BASE + 0x0cU))
+#define MPCORE_GTC_CVR_L	((uint32_t *)(MPCORE_GTC_BASE + 0x10U))
+#define MPCORE_GTC_CVR_U	((uint32_t *)(MPCORE_GTC_BASE + 0x14U))
+#define MPCORE_GTC_AUTOINCR	((uint32_t *)(MPCORE_GTC_BASE + 0x18U))
+
+/*
+ *  グローバルタイマ制御レジスタ（MPCORE_GTC_CTRL）の設定値
+ */
+#define MPCORE_GTC_CTRL_DISABLE			0x00U
+#define MPCORE_GTC_CTRL_ENABLE			0x01U
+#define MPCORE_GTC_CTRL_ENACOMP			0x02U
+#define MPCORE_GTC_CTRL_ENAINT			0x04U
+#define MPCORE_GTC_CTRL_AUTOINCR		0x08U
+#define MPCORE_GTC_CTRL_PS_SHIFT		8
+
+/*
+ *  グローバルタイマ割込みステータスレジスタ（MPCORE_GTC_ISR）の設定値
+ */
+#define MPCORE_GTC_ISR_EVENTFLAG		0x01U
+
+#endif /* __TARGET_ARCH_ARM == 7 */
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  SMPモードに設定
+ */
+Inline void
+mpcore_enable_smp(void)
+{
+	uint32_t	reg;
+
+	CP15_READ_ACTLR(reg);
+	reg |= CP15_ACTLR_SMP;
+	CP15_WRITE_ACTLR(reg);
+}
+
+/*
+ *  SCU（スヌープ制御ユニット）の操作
+ */
+
+/*
+ *  SCUのイネーブル
+ */
+Inline void
+mpcore_enable_scu(void)
+{
+	uint32_t	reg;
+
+	/*
+	 *  すべてのプロセッサをノーマルモードにする．
+	 */
+	sil_wrw_mem(MPCORE_SCU_CPUSTAT, MPCORE_SCU_CPUSTAT_ALLNORMAL);
+
+	/*
+	 *  SCUのすべてのタグを無効化する．
+	 */
+	sil_wrw_mem(MPCORE_SCU_INVALL, MPCORE_SCU_INVALL_ALLWAYS);
+
+	/*
+	 *  SCUを有効にする．
+	 */
+	reg = sil_rew_mem(MPCORE_SCU_CTRL);
+	reg |= MPCORE_SCU_CTRL_ENABLE;
+	sil_wrw_mem(MPCORE_SCU_CTRL, reg);
+	data_sync_barrier();
+}
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* TOPPERS_MPCORE_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.c	(revision 429)
@@ -0,0 +1,122 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
+ *                              Toyohashi Univ. of Technology, JAPAN
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		カーネルのMPCore依存部
+ */
+
+#include "kernel_impl.h"
+#include <sil.h>
+#include "arm.h"
+
+/*
+ *  MPCore依存の初期化
+ */
+void
+mpcore_initialize(void)
+{
+	/*
+	 *  キャッシュをディスエーブル
+	 */
+	arm_disable_cache();
+
+	/*
+	 *  コア依存の初期化
+	 */
+	core_initialize();
+
+	/*
+	 *  MPCoreをSMPモードに設定
+	 *
+	 *  Shareable属性のメモリ領域をキャッシュ有効にするには，シングル
+	 *  コアであっても，SMPモードに設定されている必要がある．
+	 */
+	mpcore_enable_smp();
+
+	/*
+	 *  SCUをイネーブル
+	 */
+	mpcore_enable_scu();
+
+	/*
+	 *  キャッシュをイネーブル
+	 */
+	arm_enable_cache();
+
+	/*
+	 * GICのディストリビュータの初期化
+	 */
+	gicd_initialize();
+
+	/*
+	 * GICのCPUインタフェースの初期化
+	 */
+	gicc_initialize();
+
+	/*
+	 *  分岐予測の無効化とイネーブル
+	 */
+	arm_invalidate_bp();
+	arm_enable_bp();
+}
+
+/*
+ *  MPCore依存の終了処理
+ */
+void
+mpcore_terminate(void)
+{
+	/*
+	 *  GICのCPUインタフェースの終了処理
+	 */
+	gicc_terminate();
+
+	/*
+	 *  GICのディストリビュータの終了処理
+	 */
+	gicd_terminate();
+
+	/*
+	 *  コア依存の終了処理
+	 */
+	core_terminate();
+}
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_kernel_impl.h	(revision 429)
@@ -0,0 +1,85 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
+ *                              Toyohashi Univ. of Technology, JAPAN
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		kernel_impl.hのMPCore依存部
+ *
+ *  このヘッダファイルは，target_kernel_impl.h（または，そこからインク
+ *  ルードされるファイル）のみからインクルードされる．他のファイルから
+ *  直接インクルードしてはならない．
+ */
+
+#ifndef TOPPERS_MPCORE_KERNEL_IMPL_H
+#define TOPPERS_MPCORE_KERNEL_IMPL_H
+
+/*
+ *  MPCoreのハードウェア資源の定義
+ */
+#include "mpcore.h"
+
+/*
+ *  MMUの使用に関する設定
+ */
+#define USE_ARM_MMU
+#define USE_ARM_SSECTION
+
+/*
+ *  GICに関する定義，コアで共通な定義
+ *
+ *  core_kernel_impl.hは，gic_kernel_impl.hからインクルードされる．
+ */
+#include "gic_kernel_impl.h"
+
+#ifndef TOPPERS_MACRO_ONLY
+
+/*
+ *  MPCore依存の初期化
+ */
+extern void mpcore_initialize(void);
+
+/*
+ *  MPcore依存の終了処理
+ */
+extern void mpcore_terminate(void);
+
+#endif /* TOPPERS_MACRO_ONLY */
+#endif /* TOPPERS_MPCORE_KERNEL_IMPL_H */
Index: EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/arch/arm_gcc/common/mpcore_timer.c	(revision 429)
@@ -0,0 +1,293 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		タイマドライバ（MPCore内蔵タイマ用）
+ *
+ *  MPCoreがプロセッサ毎に持っているプライベートタイマとウォッチドッグ，
+ *  各プロセッサからアクセスできるグローバルタイマを用いて，カーネルが
+ *  必要とする各種のタイマを実現する．
+ */
+
+#include "kernel_impl.h"
+#include "time_event.h"
+#include "target_timer.h"
+#include <sil.h>
+#include "mpcore.h"
+
+/*
+ *  スプリアス割込み対策マクロのデフォルト定義
+ */
+#ifndef MPCORE_TMR_CLEAR_INT
+#define MPCORE_TMR_CLEAR_INT()
+#endif /* MPCORE_TMR_CLEAR_INT */
+
+#ifdef USE_MPCORE_TMRWDG_HRT
+/*
+ *		プライベートタイマとウォッチドッグを用いて高分解能タイマを実現
+ */
+
+/*
+ *  タイマの起動処理
+ */
+void
+target_hrt_initialize(intptr_t exinf)
+{
+	/*
+	 *  タイマとウォッチドッグを停止する．
+	 */
+	sil_wrw_mem(MPCORE_TMR_CTRL, MPCORE_TMR_CTRL_DISABLE);
+	sil_wrw_mem(MPCORE_WDG_CTRL, MPCORE_WDG_CTRL_DISABLE);
+
+	/*
+	 *  ウォッチドッグをタイマモードに設定する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_DIS, 0x12345678);
+	sil_wrw_mem(MPCORE_WDG_DIS, 0x87654321);
+	sil_wrw_mem(MPCORE_WDG_CTRL, MPCORE_WDG_CTRL_DISABLE);
+
+	/*
+	 *  ウォッチドッグのリロード値を設定し，動作を開始する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_LR, MPCORE_WDG_LR_VALUE);
+	sil_wrw_mem(MPCORE_WDG_CTRL,
+				MPCORE_WDG_CTRL_ENABLE | MPCORE_WDG_CTRL_AUTORELOAD
+					| (MPCORE_WDG_PS_VALUE << MPCORE_WDG_CTRL_PS_SHIFT));
+
+	/*
+	 *  タイマのカウント値を0（カウントダウンして停止した状態）に設定し，
+	 *  動作を開始する．
+	 */
+	sil_wrw_mem(MPCORE_TMR_CNT, 0U);
+	sil_wrw_mem(MPCORE_TMR_CTRL,
+				MPCORE_TMR_CTRL_ENABLE | MPCORE_TMR_CTRL_ENAINT
+					| (MPCORE_TMR_PS_VALUE << MPCORE_TMR_CTRL_PS_SHIFT));
+
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_TMR_ISR, MPCORE_TMR_ISR_EVENTFLAG);
+	MPCORE_TMR_CLEAR_INT();
+}
+
+/*
+ *  タイマの停止処理
+ */
+void
+target_hrt_terminate(intptr_t exinf)
+{
+	/*
+	 *  タイマとウォッチドッグを停止する．
+	 */
+	sil_wrw_mem(MPCORE_TMR_CTRL, MPCORE_TMR_CTRL_DISABLE);
+	sil_wrw_mem(MPCORE_WDG_CTRL, MPCORE_WDG_CTRL_DISABLE);
+
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_TMR_ISR, MPCORE_TMR_ISR_EVENTFLAG);
+	MPCORE_TMR_CLEAR_INT();
+}
+
+/*
+ *  タイマ割込みハンドラ
+ */
+void
+target_hrt_handler(void)
+{
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_TMR_ISR, MPCORE_TMR_ISR_EVENTFLAG);
+	MPCORE_TMR_CLEAR_INT();
+
+	/*
+	 *  高分解能タイマ割込みを処理する．
+	 */
+	signal_time();
+}
+
+#endif /* USE_MPCORE_TMRWDG_HRT */
+
+#ifdef USE_MPCORE_GTC_HRT
+/*
+ *		グローバルタイマを用いて高分解能タイマを実現
+ */
+
+/*
+ *  タイマの起動処理
+ */
+void
+target_hrt_initialize(intptr_t exinf)
+{
+	/*
+	 *  タイマをディスエーブルする．
+	 */
+	sil_wrw_mem(MPCORE_GTC_CTRL, MPCORE_GTC_CTRL_DISABLE);
+
+	/*
+	 *  カウンタを0に初期化する（セキュアモードでないと効果がない）．
+	 */
+	sil_wrw_mem(MPCORE_GTC_COUNT_L, 0U);
+	sil_wrw_mem(MPCORE_GTC_COUNT_U, 0U);
+
+	/*
+	 *  タイマの動作を開始する（コンパレータと割込みはディスエーブル）．
+	 */
+	sil_wrw_mem(MPCORE_GTC_CTRL,
+				MPCORE_GTC_CTRL_ENABLE
+					| (MPCORE_GTC_PS_VALUE << MPCORE_GTC_CTRL_PS_SHIFT));
+
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_GTC_ISR, MPCORE_GTC_ISR_EVENTFLAG);
+}
+
+/*
+ *  タイマの停止処理
+ */
+void
+target_hrt_terminate(intptr_t exinf)
+{
+	/*
+	 *  タイマを停止する．
+	 */
+	sil_wrw_mem(MPCORE_GTC_CTRL, MPCORE_GTC_CTRL_DISABLE);
+
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_GTC_ISR, MPCORE_GTC_ISR_EVENTFLAG);
+}
+
+/*
+ *  タイマ割込みハンドラ
+ */
+void
+target_hrt_handler(void)
+{
+	/*
+	 *  タイマ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_GTC_ISR, MPCORE_GTC_ISR_EVENTFLAG);
+
+	/*
+	 *  高分解能タイマ割込みを処理する．
+	 */
+	signal_time();
+}
+
+#endif /* USE_MPCORE_GTC_HRT */
+
+#ifdef USE_MPCORE_WDG_OVRTIMER
+/*
+ *		ウォッチドッグタイマを用いてオーバランタイマを実現
+ */
+#ifdef TOPPERS_SUPPORT_OVRHDR
+
+#include "overrun.h"
+
+/*
+ *  オーバランタイマの初期化処理
+ */
+void
+target_ovrtimer_initialize(intptr_t exinf)
+{
+	/*
+	 *  ウォッチドッグを停止する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CTRL, MPCORE_WDG_CTRL_DISABLE);
+
+	/*
+	 *  ウォッチドッグをタイマモードに設定する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_DIS, 0x12345678);
+	sil_wrw_mem(MPCORE_WDG_DIS, 0x87654321);
+
+	/*
+	 *  ウォッチドッグタイマを停止した状態で設定する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CTRL,
+				MPCORE_WDG_CTRL_ENAINT
+					| (MPCORE_WDG_PS_VALUE << MPCORE_WDG_CTRL_PS_SHIFT));
+
+	/*
+	 *  ウォッチドッグ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_WDG_ISR, MPCORE_WDG_ISR_EVENTFLAG);
+}
+
+/*
+ *  オーバランタイマの終了処理
+ */
+void
+target_ovrtimer_terminate(intptr_t exinf)
+{
+	/*
+	 *  ウォッチドッグを停止する．
+	 */
+	sil_wrw_mem(MPCORE_WDG_CTRL, MPCORE_WDG_CTRL_DISABLE);
+
+	/*
+	 *  ウォッチドッグ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_WDG_ISR, MPCORE_WDG_ISR_EVENTFLAG);
+}
+
+/*
+ *  オーバランタイマ割込みハンドラ
+ */
+void
+target_ovrtimer_handler(void)
+{
+	/*
+	 *  ウォッチドッグ割込み要求をクリアする．
+	 */
+	sil_wrw_mem(MPCORE_WDG_ISR, MPCORE_WDG_ISR_EVENTFLAG);
+
+	/*
+	 *  オーバランハンドラの起動処理をする．
+	 */
+	call_ovrhdr();
+}
+
+#endif /* TOPPERS_SUPPORT_OVRHDR */
+#endif /* USE_MPCORE_WDG_OVRTIMER */
